#include "Vec3f.h"

Vec3f::Vec3f( float x, float y, float z ):
	m_x( x ),
	m_y( y ),
	m_z( z )
{}

// Functions
float Vec3f::length() const
{
	return std::sqrt(	m_x*m_x +
				m_y*m_y +
				m_z*m_z );
}

float Vec3f::lengthSquared() const
{
	return m_x*m_x + m_y*m_y + m_z*m_z;
}

float Vec3f::dotProduct( Vec3f const & other ) const
{
	return 	m_x*other.x() +
		m_y*other.y() +
		m_z*other.z();
}

/*
Vec3f Vec3f::crossProduct( Vec3f const & other ) const
{
	// TODO
}

Vec3f Vec3f::normalized() const
{
	// TODO
}

void Vec3f::normalize()
{
	// TODO
}

Vec3f Vec3f::projectOnto( Vec3f const & other ) const
{
	// TODO
}
*/

// Operators
Vec3f & Vec3f::operator = ( const Vec3f & other ) 
{
	m_x = other.x();
	m_y = other.y();
	m_z = other.z();

	return *this;
}

Vec3f Vec3f::operator + ( Vec3f const & other ) const 
{
	return Vec3f(
		m_x + other.x(),
		m_y + other.y(),
		m_z + other.z());
}

Vec3f Vec3f::operator - ( Vec3f const & other ) const 
{
	return Vec3f(
		m_x - other.x(),
		m_y - other.y(),
		m_z - other.z());
}

Vec3f Vec3f::operator * ( float factor) const 
{
	return Vec3f(
		m_x * factor,
		m_y * factor,
		m_z * factor);
}

std::ostream & operator << ( std::ostream & out, Vec3f const & vec )
{
	return out << vec.x() << " " << vec.y() << " " << vec.z();
}

// Getter/Setter Junk

float Vec3f::operator[]( int i ) const
{
	if( i == 0 )
		return m_x;
	else if( i == 1 )
		return m_y;
	else if( i == 2 )
		return m_z;
	else
		throw std::out_of_range("Vec3f index out of range (0-2).");
}

float & Vec3f::operator[]( int i )
{
	if( i == 0 )
		return m_x;
	else if( i == 1 )
		return m_y;
	else if( i == 2 )
		return m_z;
	else
		throw std::out_of_range("Vec3f index out of range (0-2).");
}

float Vec3f::x() const
{
	return m_x;
}

void Vec3f::x( float x )
{
	m_x = x;
}

float Vec3f::y() const
{
	return m_y;
}

void Vec3f::y( float y )
{
	m_y = y;
}

float Vec3f::z() const
{
	return m_z;
}

void Vec3f::z( float z )
{
	m_z = z;
}
